json-0.9.1: Support for serialising Haskell to and from JSON

Copyright | (c) Galois Inc. 2007-2009
License | BSD3
Maintainer | Sigbjorn Finne <sof@galois.com>
Stability | provisional
Portability | portable
Safe Haskell | Safe
Language | Haskell98

Text.JSON.Types

Contents

- JSON Types
- Wrapper Types

Description

Synopsis

- data JSValue
  - = JSNull
  - | JSBool !Bool
  - | JSRational Bool !Rational
  - | JSString JSString
  - | JSArray [JSValue]
  - | JSObject (JSObject JSValue)
- newtype JSString = JSONString {
  - fromJSString :: String
  }
- toJSString :: String -> JSString
- newtype JSObject e = JSONObject {
  - fromJSObject :: [(String, e)]
  }
- toJSObject :: [(String, a)] -> JSObject a
- get_field :: JSObject a -> String -> Maybe a
- set_field :: JSObject a -> String -> a -> JSObject a

# JSON Types

data JSValue Source #

JSON values

The type to which we encode Haskell values. There's a set of primitives, and a couple of heterogenous collection types.

Objects:

An object structure is represented as a pair of curly brackets surrounding zero or more name/value pairs (or members). A name is a string. A single colon comes after each name, separating the name from the value. A single comma separates a value from a following name.

Arrays:

An array structure is represented as square brackets surrounding zero or more values (or elements). Elements are separated by commas.

Only valid JSON can be constructed this way

Constructors

JSNull |
JSBool !Bool |
JSRational Bool !Rational |
JSString JSString |
JSArray [JSValue] |
JSObject (JSObject JSValue) |

Instances

Eq JSValue Source # |
Methods (==) :: JSValue -> JSValue -> Bool # (/=) :: JSValue -> JSValue -> Bool #
Ord JSValue Source # |
Methods compare :: JSValue -> JSValue -> Ordering # (<) :: JSValue -> JSValue -> Bool # (<=) :: JSValue -> JSValue -> Bool # (>) :: JSValue -> JSValue -> Bool # (>=) :: JSValue -> JSValue -> Bool # max :: JSValue -> JSValue -> JSValue # min :: JSValue -> JSValue -> JSValue #
Read JSValue Source # |
Methods readsPrec :: Int -> ReadS JSValue # readList :: ReadS [JSValue] # readPrec :: ReadPrec JSValue # readListPrec :: ReadPrec [JSValue] #
Show JSValue Source # |
Methods showsPrec :: Int -> JSValue -> ShowS # show :: JSValue -> String # showList :: [JSValue] -> ShowS #
JSON JSValue Source # | To ensure we generate valid JSON, we map Haskell types to JSValue internally, then pretty print that.
Methods readJSON :: JSValue -> Result JSValue Source # showJSON :: JSValue -> JSValue Source # readJSONs :: JSValue -> Result [JSValue] Source # showJSONs :: [JSValue] -> JSValue Source #

# Wrapper Types

newtype JSString Source #

Strings can be represented a little more efficiently in JSON

Constructors

JSONString |

Fields

- fromJSString :: String

Instances

Eq JSString Source # |
Methods (==) :: JSString -> JSString -> Bool # (/=) :: JSString -> JSString -> Bool #
Ord JSString Source # |
Methods compare :: JSString -> JSString -> Ordering # (<) :: JSString -> JSString -> Bool # (<=) :: JSString -> JSString -> Bool # (>) :: JSString -> JSString -> Bool # (>=) :: JSString -> JSString -> Bool # max :: JSString -> JSString -> JSString # min :: JSString -> JSString -> JSString #
Read JSString Source # |
Methods readsPrec :: Int -> ReadS JSString # readList :: ReadS [JSString] # readPrec :: ReadPrec JSString # readListPrec :: ReadPrec [JSString] #
Show JSString Source # |
Methods showsPrec :: Int -> JSString -> ShowS # show :: JSString -> String # showList :: [JSString] -> ShowS #
JSKey JSString Source # |
Methods toJSKey :: JSString -> String Source # fromJSKey :: String -> Maybe JSString Source #
JSON JSString Source # |
Methods readJSON :: JSValue -> Result JSString Source # showJSON :: JSString -> JSValue Source # readJSONs :: JSValue -> Result [JSString] Source # showJSONs :: [JSString] -> JSValue Source #

toJSString :: String -> JSString Source #

Turn a Haskell string into a JSON string.

newtype JSObject e Source #

As can association lists

Constructors

JSONObject |

Fields

- fromJSObject :: [(String, e)]

Instances

Eq e => Eq (JSObject e) Source # |
Methods (==) :: JSObject e -> JSObject e -> Bool # (/=) :: JSObject e -> JSObject e -> Bool #
Ord e => Ord (JSObject e) Source # |
Methods compare :: JSObject e -> JSObject e -> Ordering # (<) :: JSObject e -> JSObject e -> Bool # (<=) :: JSObject e -> JSObject e -> Bool # (>) :: JSObject e -> JSObject e -> Bool # (>=) :: JSObject e -> JSObject e -> Bool # max :: JSObject e -> JSObject e -> JSObject e # min :: JSObject e -> JSObject e -> JSObject e #
Read e => Read (JSObject e) Source # |
Methods readsPrec :: Int -> ReadS (JSObject e) # readList :: ReadS [JSObject e] # readPrec :: ReadPrec (JSObject e) # readListPrec :: ReadPrec [JSObject e] #
Show e => Show (JSObject e) Source # |
Methods showsPrec :: Int -> JSObject e -> ShowS # show :: JSObject e -> String # showList :: [JSObject e] -> ShowS #
JSON a => JSON (JSObject a) Source # |
Methods readJSON :: JSValue -> Result (JSObject a) Source # showJSON :: JSObject a -> JSValue Source # readJSONs :: JSValue -> Result [JSObject a] Source # showJSONs :: [JSObject a] -> JSValue Source #

toJSObject :: [(String, a)] -> JSObject a Source #

Make JSON object out of an association list.

get_field :: JSObject a -> String -> Maybe a Source #

Get the value of a field, if it exist.

set_field :: JSObject a -> String -> a -> JSObject a Source #

Set the value of a field. Previous values are overwritten.